NO_OF_ARTICLES_TO_EVALUATE = 400
DEBUG = true

require 'rexml/document'
require 'pp'

SID = if ARGV.length == 0 
  ENV['SID']
else
  SID = ARGV.first
end


def execute_request(url) 
  command = "curl --header \"Cookie: SID=#{SID}\" "
  command << "\"#{url}\""
  command << " 2> /dev/null"
  command << " | tidy -i -xml 2>/dev/null" if DEBUG
  
  output = IO.popen(command).read
  puts output if DEBUG
  REXML::Document.new(output)
end

## reading-list

reading_list_unread_ids= []
reading_list_d = execute_request("http://www.google.com/reader/atom/user/-/state/com.google/reading-list?n=#{NO_OF_ARTICLES_TO_EVALUATE}&r=n")
reading_list_d.elements.each("/feed/entry") do |entry_element|
  id = entry_element.elements["./id"].text.strip
  unread = entry_element.elements["category[@label='read']"].nil?
  reading_list_unread_ids << id if unread
end
puts "Found #{reading_list_unread_ids.size} unread ids in the reading list."

## ids

url = "http://www.google.com/reader/api/0/stream/items/ids"
url << "?s=user/-/state/com.google/reading-list&xt=user/-/state/com.google/read&n=10000"#{}"#{reading_list_unread_ids.size}"

unread_ids= []
unread_ids_d = execute_request(url)
unread_ids_d.elements.each("//number") do |number|
  hex = "%x" % number.text.strip
  hex = hex[3..-1] if hex =~ /\.\.f/
  puts "number !#{number.text.strip}! to hex !#{hex}!" if DEBUG
  unread_ids << "tag:google.com,2005:reader/item/#{hex}"
end

## report

puts "Found #{unread_ids.size} unread ids in the response of the ids request."

puts "id               r-list   ids"
puts "----------------!-------!------"
reading_list_unread_ids.each do |reading_list_unread_id|
  also_unread_in_ids = unread_ids.include?(reading_list_unread_id) rescue false
  puts "%15s%6s %6s" % [reading_list_unread_id.split("/").last, 
                        true, 
                        also_unread_in_ids]  
  
end